import { Falsey } from 'utility-types';
/**
 * Creates an array with all falsey values removed. The values `false`, `null`, `0`, `""`, `undefined`, and `NaN` are falsey.
 *
 * Contribution to minified bundle size, when it is the only function imported:
 * - Lodash: 114 bytes
 * - Micro-dash: 53 bytes
 */
export declare function compact<T>(array: readonly T[]): Array<Exclude<T, Falsey>>;
