import { ArrayIteratee, ObjectIteratee } from '../interfaces';
/**
 * Checks if `predicate` returns truty for **all** elements of `collection`. Iteration is stopped once predicate returns falsey.
 *
 * **Note:** This method returns `true` for [empty collections](https://en.wikipedia.org/wiki/Empty_set) because [everything is true](https://en.wikipedia.org/wiki/Vacuous_truth) of elements of empty collections.
 *
 * Contribution to minified bundle size, when it is the only function imported:
 * - Lodash: 14,709 bytes
 * - Micro-dash: 328 bytes
 */
export declare function every<T>(array: readonly T[] | undefined, predicate: ArrayIteratee<T, any>): boolean;
export declare function every<T>(object: T | undefined, predicate: ObjectIteratee<T, any>): boolean;
