import { ArrayIteratee, Nil, ObjectIteratee } from '../interfaces';
/**
 * Iterates over elements of `collection` and invokes `iteratee` for each element. Iteratee functions may exit iteration early by explicitly returning `false`.
 *
 * Contribution to minified bundle size, when it is the only function imported:
 * - Lodash: 3,975 bytes
 * - Micro-dash: 254 bytes
 */
export declare function forEach<T extends Nil | readonly any[]>(array: T, iteratee: ArrayIteratee<NonNullable<T>[number], boolean | void>): T;
export declare function forEach<T>(object: T, iteratee: ObjectIteratee<NonNullable<T>, boolean | void>): T;
export declare function forEachOfArray<T>(array: readonly T[], iteratee: ArrayIteratee<T, boolean | void>): void;
