import { IfCouldBe, Nil } from '../interfaces';
/**
 * This method is like `_.reduce` except that it iterates over elements of `collection` from right to left.
 *
 * Contribution to minified bundle size, when it is the only function imported:
 * - Lodash: 14,591 bytes
 * - Micro-dash: 387 bytes
 */
export declare function reduceRight<T extends Nil | readonly any[]>(array: T, iteratee: (accumulator: NonNullable<T>[number], value: NonNullable<T>[number], index: number) => NonNullable<T>[number]): IfCouldBe<T, Nil, undefined> | NonNullable<T>[number];
export declare function reduceRight<E, A>(array: Nil | readonly E[], iteratee: (accumulator: A, value: E, index: number) => A, accumulator: A): A;
export declare function reduceRight<T>(object: T, iteratee: (accumulator: NonNullable<T>[keyof NonNullable<T>], value: NonNullable<T>[keyof NonNullable<T>], key: keyof NonNullable<T>) => NonNullable<T>[keyof NonNullable<T>]): IfCouldBe<T, Nil, undefined> | NonNullable<T>[keyof NonNullable<T>];
export declare function reduceRight<T, A>(object: T, iteratee: (accumulator: A, value: NonNullable<T>[keyof NonNullable<T>], key: keyof NonNullable<T>) => A, accumulator: A): A;
