import { ArrayIteratee, Cast, IfCouldBe, KeyNarrowingIteratee, Narrow, Nil, ObjectIteratee, ValueNarrowingIteratee } from '../interfaces';
declare type DefiniteValueMatches<T, O> = {
    [K in keyof T]: T[K] extends O ? K : never;
}[keyof T];
declare type PossibleValueMatches<T, O> = {
    [K in keyof T]: IfCouldBe<T[K], O, Cast<K, string>>;
}[keyof T];
declare type DefiniteKeyMatch<T, O> = {
    [K in keyof T]: Cast<K, string> extends O ? K : never;
}[keyof T];
declare type PossibleKeyMatch<T, O> = {
    [K in keyof T]: IfCouldBe<Cast<K, string>, O, Narrow<Cast<K, string>, O>>;
}[keyof T];
/**
 * This method is like `find` except that it returns the key of the first element `predicate` returns truthy for instead of the element itself.
 *
 * Contribution to minified bundle size, when it is the only function imported:
 * - Lodash: 14,287 bytes
 * - Micro-dash: 381 bytes
 */
export declare function findKey<T>(array: T[], predicate: ArrayIteratee<T, boolean>): string | undefined;
export declare function findKey<I, T extends NonNullable<I>, O>(object: I, predicate: ValueNarrowingIteratee<T, O>): (DefiniteValueMatches<T, O> extends never ? undefined : never) | IfCouldBe<I, Nil, undefined> | PossibleValueMatches<T, O>;
export declare function findKey<I, T extends NonNullable<I>, O>(object: I, predicate: KeyNarrowingIteratee<T, O>): (DefiniteKeyMatch<T, O> extends never ? undefined : never) | IfCouldBe<I, Nil, undefined> | PossibleKeyMatch<T, O>;
export declare function findKey<T>(object: Nil | T, predicate: ObjectIteratee<T, boolean>): Cast<keyof T, string> | undefined;
export {};
