import { Nil, StringifiedKey } from '../interfaces';
/**
 * Creates an array of the own enumerable property names of object.
 *
 * Differences from lodash:
 * - does not give any special consideration for arguments objects, strings, or prototype objects (e.g. many will have `'length'` in the returned array)
 *
 * Contribution to minified bundle size, when it is the only function imported:
 * - Lodash: 3,430 bytes
 * - Micro-dash: 182 bytes
 */
export declare function keys<T>(object: Nil | T): Array<StringifiedKey<T>>;
export declare function keysOfNonArray<T>(object: Nil | T): Array<StringifiedKey<T>>;
