/**
 * Invokes the iteratee `n` times, returning an array of the results of each invocation.
 *
 * Differences from lodash:
 * - has undefined behavior when given a non natural number for `n`
 * - does not provide a default for `iteratee`
 *
 * Contribution to minified bundle size, when it is the only function imported:
 * - Lodash: 1,706 bytes
 * - Micro-dash: 85 bytes
 */
export declare function times<T>(n: number, iteratee: (index: number) => T): T[];
